<script setup lang="ts" generic="T extends { id: string }, I">
import type { Repository } from "~/utils/types/repository";

const props = defineProps<{
  repository: Repository<T, I>;
  formLabel?: string;
  submitLabel?: string;
  reuseLabel?: string;
}>();

const formLabel = computed(() =>
  props.formLabel ? props.formLabel : `Add a ${props.repository.name}`,
);
const { addMessage } = useSnackBarStore();

const items = computed(() => props.repository.data.value);
const newItem = ref(props.repository.newItem()) as Ref<I>;

const showForm = ref(false);
const idToRemove = ref("");
const noData = computed(() => !showForm.value && items.value.length === 0);

const submitError = ref<string | null>(null);
const clear = (callback: () => void) => {
  newItem.value = props.repository.newItem();
  submitError.value = null;
  nextTick(callback);
};

const submitLoading = ref(false);
const submit = (resetValidations: () => void, reuse: boolean) => {
  submitLoading.value = true;
  props.repository
    .add(newItem.value)
    .then(() => {
      if (!reuse) {
        clear(() => {
          resetValidations();
          showForm.value = false;
          addMessage({
            text: `${props.repository.name} submitted`,
            color: "success",
          });
        });
      } else {
        (props.repository.reuseIgnore || []).forEach((key) => {
          const defaultItem = props.repository.newItem();
          newItem.value = { ...newItem.value, [key]: defaultItem[key] };
        });
        nextTick(() => {
          resetValidations();
          addMessage({
            text: `${props.repository.name} submitted`,
            color: "success",
          });
        });
      }
    })
    .catch(() => {
      submitError.value = `Failed to submit ${props.repository.name}`;
    })
    .finally(() => {
      submitLoading.value = false;
    });
};

const removeLoading = ref(false);
const remove = async (id: string) => {
  removeLoading.value = true;
  try {
    await props.repository.remove(id);
    idToRemove.value = "";
  } catch {
    addMessage({
      text: `Failed to remove ${props.repository.name}`,
      color: "error",
    });
  } finally {
    removeLoading.value = false;
  }
};

const update = (updatedItem: I) => {
  newItem.value = updatedItem;
};
</script>

<template>
  <v-row class="pa-4">
    <v-col cols="12" xl="7">
      <template v-for="{ id, ...item } in items" :key="id">
        <v-row>
          <v-col>
            <slot
              name="item"
              :item="item"
              :delete-preview="false"
              :submit-preview="false"
            />
            <RemoveButton
              :open="idToRemove === id"
              :loading="removeLoading"
              @update:open="(v: boolean) => (idToRemove = v ? id : '')"
              @confirm="remove(id)"
            >
              <slot
                name="item"
                :item="item"
                :delete-preview="true"
                :submit-preview="false"
              />
            </RemoveButton>
          </v-col>
        </v-row>
      </template>
      <client-only>
        <v-expand-transition>
          <NoDataText v-if="noData">No data</NoDataText>
        </v-expand-transition>
        <v-expand-transition>
          <v-row v-show="showForm">
            <v-col>
              <div class="text-disabled">Preview</div>
              <slot
                name="item"
                :item="props.repository.preview(newItem)"
                :delete-preview="false"
                :submit-preview="true"
              />
            </v-col>
          </v-row>
        </v-expand-transition>
      </client-only>
    </v-col>
    <v-col>
      <v-btn
        :ripple="false"
        :elevation="3"
        class="mb-4"
        :min-width="240"
        color="primary"
        :append-icon="showForm ? 'mdi-close' : 'mdi-plus'"
        @click="showForm = !showForm"
      >
        {{ formLabel }}
      </v-btn>
      <v-expand-transition>
        <FormView
          v-show="showForm"
          :reuse="props.repository.reuse"
          :loading="submitLoading"
          :submit-label="props.submitLabel"
          :reuse-label="props.reuseLabel"
          @submit="(cb) => submit(cb, false)"
          @reuse="(cb) => submit(cb, true)"
          @clear="clear"
        >
          <slot :item="newItem" :update="update" name="inputs" />
        </FormView>
      </v-expand-transition>
    </v-col>
  </v-row>
</template>
